/**
 * Copyright (c) 2018 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see http://www.gnu.org/licenses/
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.component.framework.su;

import java.io.InputStream;
import java.net.URI;
import java.util.Map;
import java.util.Set;

import javax.activation.DataHandler;
import javax.jbi.messaging.ExchangeStatus;
import javax.jbi.messaging.Fault;
import javax.jbi.messaging.MessageExchange;
import javax.jbi.messaging.MessageExchange.Role;
import javax.jbi.messaging.MessagingException;
import javax.jbi.messaging.NormalizedMessage;
import javax.jbi.servicedesc.ServiceEndpoint;
import javax.security.auth.Subject;
import javax.xml.namespace.QName;
import javax.xml.transform.Source;

import org.ow2.petals.component.framework.api.message.Exchange;
import org.w3c.dom.Document;
import org.w3c.dom.DocumentFragment;

public class MockExchange implements Exchange {

    private final QName interfaceName;

    private final QName serviceName;

    private final String endpointName;

    private final QName operationName;

    public MockExchange(final QName interfaceName, final QName serviceName, final String endpointName,
            final QName operationName) {
        this.interfaceName = interfaceName;
        this.serviceName = serviceName;
        this.endpointName = endpointName;
        this.operationName = operationName;
    }

    @Override
    public void addInMessageAttachment(final String name, final DataHandler dataHandler) throws MessagingException {
        // NOP
    }

    @Override
    public void addOutMessageAttachment(final String name, final DataHandler dataHandler) throws MessagingException {
        // NOP
    }

    @Override
    public Fault createFault() throws MessagingException {
        return null;
    }

    @Override
    public ServiceEndpoint getEndpoint() {
        if (this.endpointName == null) {
            return null;
        } else {
            return new ServiceEndpoint() {

                @Override
                public QName getServiceName() {
                    return serviceName;
                }

                @Override
                public QName[] getInterfaces() {
                    return new QName[] { interfaceName };
                }

                @Override
                public String getEndpointName() {
                    return endpointName;
                }

                @Override
                public DocumentFragment getAsReference(final QName operationName) {
                    return null;
                }
            };
        }
    }

    @Override
    public String getEndpointName() {
        return null;
    }

    @Override
    public Exception getError() {
        return null;
    }

    @Override
    public String getExchangeId() {
        return null;
    }

    @Override
    public MessageExchange getMessageExchange() {
        return null;
    }

    @Override
    public Fault getFault() {
        return null;
    }

    @Override
    public NormalizedMessage getInMessage() {
        return null;
    }

    @Override
    public DataHandler getInMessageAttachment(final String name) throws MessagingException {
        return null;
    }

    @Override
    public Set<String> getInMessageAttachmentNames() throws MessagingException {
        return null;
    }

    @Override
    public Set<DataHandler> getInMessageAttachments() throws MessagingException {
        return null;
    }

    @Override
    public Document getInMessageContentAsDocument() throws MessagingException {
        return null;
    }

    @Override
    public Document getInMessageContentAsDocument(final boolean forkSource) throws MessagingException {
        return null;
    }

    @Override
    public Source getInMessageContentAsSource() throws MessagingException {
        return null;
    }

    @Override
    public Object getInMessageProperty(final String name) throws MessagingException {
        return null;
    }

    @Override
    public Set<String> getInMessagePropertyNames() throws MessagingException {
        return null;
    }

    @Override
    public Subject getInSubject() throws MessagingException {
        return null;
    }

    @Override
    public QName getInterfaceName() {
        return this.interfaceName;
    }

    @Override
    public QName getOperation() {
        return this.operationName;
    }

    @Override
    public String getOperationName() {
        return null;
    }

    @Override
    public NormalizedMessage getOutMessage() {
        return null;
    }

    @Override
    public DataHandler getOutMessageAttachment(final String name) throws MessagingException {
        return null;
    }

    @Override
    public Set<String> getOutMessageAttachmentNames() throws MessagingException {
        return null;
    }

    @Override
    public Set<DataHandler> getOutMessageAttachments() throws MessagingException {
        return null;
    }

    @Override
    public Document getOutMessageContentAsDocument() throws MessagingException {
        return null;
    }

    @Override
    public Document getOutMessageContentAsDocument(final boolean forkSource) throws MessagingException {
        return null;
    }

    @Override
    public Source getOutMessageContentAsSource() throws MessagingException {
        return null;
    }

    @Override
    public Object getOutMessageProperty(final String name) throws MessagingException {
        return null;
    }

    @Override
    public Set<String> getOutMessagePropertyNames() throws MessagingException {
        return null;
    }

    @Override
    public Subject getOutSubject() throws MessagingException {
        return null;
    }

    @Override
    public URI getPattern() {
        return null;
    }

    @Override
    public Object getProperty(final String name) {
        return null;
    }

    @Override
    public Set<String> getPropertyNames() {
        return null;
    }

    @Override
    public Role getRole() {
        return null;
    }

    @Override
    public QName getService() {
        return this.serviceName;
    }

    @Override
    public ExchangeStatus getStatus() {
        return null;
    }

    @Override
    public boolean isActiveStatus() {
        return false;
    }

    @Override
    public boolean isConsumerRole() {
        return false;
    }

    @Override
    public boolean isDoneStatus() {
        return false;
    }

    @Override
    public boolean isErrorStatus() {
        return false;
    }

    @Override
    public boolean isInMessage() {
        return false;
    }

    @Override
    public boolean isInOnlyPattern() {
        return false;
    }

    @Override
    public boolean isInOptionalOutPattern() {
        return false;
    }

    @Override
    public boolean isInOutPattern() {
        return false;
    }

    @Override
    public boolean isOutMessage() {
        return false;
    }

    @Override
    public boolean isFaultMessage() {
        return false;
    }

    @Override
    public boolean isProviderRole() {
        return false;
    }

    @Override
    public boolean isRobustInOnlyPattern() {
        return false;
    }

    @Override
    public boolean isTransacted() {
        return false;
    }

    @Override
    public void setActiveStatus() throws MessagingException {
        // NOP
    }

    @Override
    public void setDoneStatus() throws MessagingException {
        // NOP
    }

    @Override
    public void setEndpoint(final ServiceEndpoint endpoint) {
        // NOP
    }

    @Override
    public void setError(final Exception error) {
        // NOP
    }

    @Override
    public void setErrorStatus() throws MessagingException {
        // NOP
    }

    @Override
    public void setFault(final Fault fault) throws MessagingException {
        // NOP
    }

    @Override
    public void setInMessage(final NormalizedMessage msg) throws MessagingException {
        // NOP
    }

    @Override
    public void setInMessageAttachment(final String name, final DataHandler attachement) throws MessagingException {
        // NOP
    }

    @Override
    public void setInMessageAttachments(final Map<String, DataHandler> attachements) throws MessagingException {
        // NOP
    }

    @Override
    public void setInMessageContent(final Document inContent) throws MessagingException {
        // NOP
    }

    @Override
    public void setInMessageContent(final InputStream inContent) throws MessagingException {
        // NOP
    }

    @Override
    public void setInMessageContent(final Source inContent) throws MessagingException {
        // NOP
    }

    @Override
    public void setInMessageProperties(final Map<String, Object> properties) throws MessagingException {
        // NOP
    }

    @Override
    public void setInMessageProperty(final String name, final Object value) throws MessagingException {
        // NOP
    }

    @Override
    public void setInSubject(final Subject subject) {
        // NOP
    }

    @Override
    public void setInterfaceName(final QName interfaceName) {
        // NOP
    }

    @Override
    public void setOperation(final QName name) {
        // NOP
    }

    @Override
    public void setOutMessage(final NormalizedMessage msg) throws MessagingException {
        // NOP
    }

    @Override
    public void setOutMessageAttachment(final String name, final DataHandler attachment) throws MessagingException {
        // NOP
    }

    @Override
    public void setOutMessageAttachments(final Map<String, DataHandler> attachements) throws MessagingException {
        // NOP
    }

    @Override
    public void setOutMessageContent(final Document outContent) throws MessagingException {
        // NOP
    }

    @Override
    public void setOutMessageContent(final InputStream inContent) throws MessagingException {
        // NOP
    }

    @Override
    public void setOutMessageContent(final Source outContent) throws MessagingException {
        // NOP
    }

    @Override
    public void setOutMessageProperties(final Map<String, Object> properties) throws MessagingException {
        // NOP
    }

    @Override
    public void setOutMessageProperty(final String name, final Object value) throws MessagingException {
        // NOP
    }

    @Override
    public void setOutSubject(final Subject subject) {
        // NOP
    }

    @Override
    public void setProperty(final String name, final Object obj) {
        // NOP
    }

    @Override
    public void setService(final QName service) {
        // NOP
    }

    @Override
    public void setStatus(final ExchangeStatus status) throws MessagingException {
        // NOP
    }

    @Override
    public boolean amIOwner() {
        return false;
    }

}
